<#macro typeTransfer type>
	<#if "boolean" == type>
Boolean<#return>
	<#elseif "integer8" == type>
int<#return>
	<#elseif "integer16" == type>
int<#return>
	<#elseif "integer32" == type>
int<#return>
	<#elseif "integer64" == type>
Number<#return>
	<#elseif "decimal32" == type>
Number<#return>
	<#elseif "decimal64" == type>
Number<#return>
	<#elseif "string" == type>
String<#return>
	<#elseif "date" == type>
Date<#return>
	<#elseif "object" == type>
Object<#return>
	<#elseif "array" == type>
Array<#return>
	<#elseif "dictionary" == type>
Object<#return>
	<#else>
${type}<#return>
	</#if>
</#macro>
<#macro valueTransfer type value>
	<#if "boolean" == type && "true" == value>
true<#return>
	<#elseif "boolean" == type>
false<#return>
	<#elseif "null" == value>
null<#return>
	<#elseif "string" == type>
"${value}"<#return>
	<#elseif "date" == type && "new" == value>
new Date()<#return>
	<#elseif "array" == type && "new" == value>
new Array()<#return>
	<#elseif "dictionary" == type && "new" == value>
new Object()<#return>
	<#else>
${value}<#return>
</#if>
</#macro>
package<#if package?? && "" != package> ${package}</#if>
{

<#if macros??>
	<#if macros.name?? && "" != macros.name>
		<#if macros.note?? && "" != macros.note>
	/** ${macros.note} */
		</#if>
	public class ${macros.name}
	{

		<#assign needGap = false/>
		<#list macros.macros as macro>
			<#if macro.name?? && "" != macro.name && macro.type?? && "" != macro.type && macro.value?? && "" != macro.value>
				<#assign needGap = true/>
				<#if macro.note?? && "" != macro.note>
		/** ${macro.note} */
				</#if>
		static public const ${macro.name?upper_case}:<@typeTransfer type = macro.type/> = <@valueTransfer type = macro.type value = macro.value/>;
			</#if>
		</#list>
		<#list macros.groups as group>
			<#assign gapped = false/>
			<#if group.name?? && "" != group.name && group.type?? && "" != group.type && group.value?? && "" != group.value>
				<#if needGap>

				</#if>
				<#assign needGap = true gapped = true/>
				<#if group.note?? && "" != group.note>
		/** ${group.note} */
				</#if>
		static public const ${group.name?upper_case}:<@typeTransfer type = group.type/> = <@valueTransfer type = group.type value = group.value/>;
			</#if>
			<#list group.macros as macro>
				<#if macro.name?? && "" != macro.name && macro.type?? && "" != macro.type && macro.value?? && "" != macro.value>
					<#if needGap && !gapped>

					</#if>
					<#assign gapped = true/>
					<#if macro.note?? && "" != macro.note>
		/** ${macro.note} */
					</#if>
		static public const ${macro.name?upper_case}:<@typeTransfer type = macro.type/> = <@valueTransfer type = macro.type value = macro.value/>;
				</#if>
			</#list>
		</#list>

	}
	</#if>
</#if>
}