<#macro typeTransfer type>
	<#if "boolean" == type>
boolean<#return>
	<#elseif "integer8" == type>
byte<#return>
	<#elseif "integer16" == type>
short<#return>
	<#elseif "integer32" == type>
int<#return>
	<#elseif "integer64" == type>
long<#return>
	<#elseif "decimal32" == type>
float<#return>
	<#elseif "decimal64" == type>
double<#return>
	<#elseif "string" == type>
String<#return>
	<#elseif "date" == type>
java.util.Date<#return>
	<#elseif "object" == type>
Object<#return>
	<#elseif "array" == type>
java.util.List<Object><#return>
	<#elseif "dictionary" == type>
java.util.Map<Object, Object><#return>
	<#else>
${type}<#return>
	</#if>
</#macro>
<#macro valueTransfer type value>
	<#if "boolean" == type && "true" == value>
true<#return>
	<#elseif "boolean" == type>
false<#return>
	<#elseif "integer64" == type>
${value}L<#return>
	<#elseif "decimal32" == type>
${value}F<#return>
	<#elseif "null" == value>
null<#return>
	<#elseif "string" == type>
"${value}"<#return>
	<#elseif "date" == type && "new" == value>
new java.util.Date()<#return>
	<#elseif "array" == type && "new" == value>
new java.util.ArrayList<>()<#return>
	<#elseif "dictionary" == type && "new" == value>
new java.util.HashMap<>()<#return>
	<#else>
${value}<#return>
</#if>
</#macro>
<#if package?? && "" != package>
package ${package};

</#if>
<#if macros??>
	<#if macros.name?? && "" != macros.name>
		<#if macros.note?? && "" != macros.note>
/** ${macros.note} */
		</#if>
public class ${macros.name} {
	
		<#assign needGap = false/>
		<#list macros.macros as macro>
			<#if macro.name?? && "" != macro.name && macro.type?? && "" != macro.type && macro.value?? && "" != macro.value>
				<#assign needGap = true/>
				<#if macro.note?? && "" != macro.note>
	/** ${macro.note} */
				</#if>
	static public final <@typeTransfer type = macro.type/> ${macro.name?upper_case} = <@valueTransfer type = macro.type value = macro.value/>;
			</#if>
		</#list>
		<#list macros.groups as group>
			<#assign gapped = false/>
			<#if group.name?? && "" != group.name && group.type?? && "" != group.type && group.value?? && "" != group.value>
				<#if needGap>

				</#if>
				<#assign needGap = true gapped = true/>
				<#if group.note?? && "" != group.note>
	/** ${group.note} */
				</#if>
	static public final <@typeTransfer type = group.type/> ${group.name?upper_case} = <@valueTransfer type = group.type value = group.value/>;
			</#if>
			<#list group.macros as macro>
				<#if macro.name?? && "" != macro.name && macro.type?? && "" != macro.type && macro.value?? && "" != macro.value>
					<#if needGap && !gapped>

					</#if>
					<#assign gapped = true/>
					<#if macro.note?? && "" != macro.note>
	/** ${macro.note} */
					</#if>
	static public final <@typeTransfer type = macro.type/> ${macro.name?upper_case} = <@valueTransfer type = macro.type value = macro.value/>;
				</#if>
			</#list>
		</#list>
	
}
	</#if>
</#if>