<#macro typeTransfer type>
	<#if "boolean" == type>
Boolean<#return>
	<#elseif "integer8" == type>
int<#return>
	<#elseif "integer16" == type>
int<#return>
	<#elseif "integer32" == type>
int<#return>
	<#elseif "integer64" == type>
Number<#return>
	<#elseif "decimal32" == type>
Number<#return>
	<#elseif "decimal64" == type>
Number<#return>
	<#elseif "string" == type>
String<#return>
	<#elseif "date" == type>
Date<#return>
	<#elseif "object" == type>
Object<#return>
	<#elseif "array" == type>
Array<#return>
	<#elseif "dictionary" == type>
Object<#return>
	<#else>
${type}<#return>
	</#if>
</#macro>
<#macro valueTransfer type value>
	<#if "boolean" == type && "true" == value>
true<#return>
	<#elseif "boolean" == type>
false<#return>
	<#elseif "null" == value>
null<#return>
	<#elseif "string" == type>
"${value}"<#return>
	<#elseif "date" == type && "new" == value>
new Date()<#return>
	<#elseif "array" == type && "new" == value>
new Array()<#return>
	<#elseif "dictionary" == type && "new" == value>
new Object()<#return>
	<#else>
${value}<#return>
</#if>
</#macro>
package<#if package?? && "" != package> ${package}</#if>
{
<#if object??>
	<#list object.importsAs3 as import>
	import ${import};
		<#if import_index + 1 == object.importsAs3?size>

		</#if>
	</#list>
	<#if object.name?? && "" != object.name>
		<#if object.note?? && "" != object.note>
	/** ${object.note} */
		</#if>
	public class ${object.name}<#if object.extend?? && "" != object.extend> extends ${object.extend}</#if>
	{
	
		//============================================================================
		//PROPERTY
		//============================================================================
		<#list object.properties as property>
			<#if property.name?? && "" != property.name>
				<#if property.typeAs3??>
					<#if "" != property.typeAs3>
						<#if property.valueAs3??>
		private var _${property.name}:${property.typeAs3}<#if "" != property.valueAs3> = ${property.valueAs3}</#if>;
						<#elseif property.value??>
		private var _${property.name}:${property.typeAs3}<#if "" != property.value> = ${property.value}</#if>;
						<#else>
		private var _${property.name}:${property.typeAs3};
						</#if>
					</#if>
				<#elseif property.type?? && "" != property.type>
					<#if property.valueAs3??>
		private var _${property.name}:<@typeTransfer type = property.type/><#if "" != property.valueAs3> = <@valueTransfer type = property.type value=property.valueAs3/></#if>;
					<#elseif property.value??>
		private var _${property.name}:<@typeTransfer type = property.type/><#if "" != property.value> = <@valueTransfer type = property.type value=property.value/></#if>;
					<#else>
		private var _${property.name}:<@typeTransfer type = property.type/>;
					</#if>
				</#if>
			</#if>
		</#list>
		//============================================================================
		//CONSTRUCTOR
		//============================================================================
		public function ${object.name}() {}
		//============================================================================
		//GETTER_SETTER
		//============================================================================
		<#assign needGap = false/>
		<#list object.properties as property>
			<#if property.name?? && "" != property.name>
				<#if property.typeAs3??>
					<#if "" != property.typeAs3>
						<#if needGap>

						</#if>
						<#assign needGap = true/>
						<#if property.note?? && "" != property.note>
		/** ${property.note} */
						</#if>
		public function get ${property.name}():${property.typeAs3} { return _${property.name}; }
					</#if>
				<#elseif property.type?? && "" != property.type>
					<#if needGap>

					</#if>
					<#assign needGap = true/>
					<#if property.note?? && "" != property.note>
		/** ${property.note} */
					</#if>
		public function get ${property.name}():<@typeTransfer type = property.type/> { return _${property.name}; }
				</#if>
				<#if property.typeAs3??>
					<#if "" != property.typeAs3>
						<#if property.note?? && "" != property.note>
		/** @private */
						</#if>
		public function set ${property.name}(value:${property.typeAs3}):void { this._${property.name} = value; }
					</#if>
				<#elseif property.type?? && "" != property.type>
					<#if property.note?? && "" != property.note>
		/** @private */
					</#if>
		public function set ${property.name}(value:<@typeTransfer type = property.type/>):void { this._${property.name} = value; }
				</#if>
			</#if>
		</#list>
		
	}
	</#if>
</#if>
}