<#macro typeTransfer type>
	<#if "boolean" == type>
TINYINT<#return>
	<#elseif "integer8" == type>
TINYINT<#return>
	<#elseif "integer16" == type>
SMALLINT<#return>
	<#elseif "integer32" == type>
INT<#return>
	<#elseif "integer64" == type>
BIGINT<#return>
	<#elseif "decimal32" == type>
FLOAT<#return>
	<#elseif "decimal64" == type>
DOUBLE<#return>
	<#elseif "string" == type>
VARCHAR(255)<#return>
	<#elseif "date" == type>
DATETIME<#return>
	<#else>
${type}<#return>
	</#if>
</#macro>
<#macro valueTransfer type value>
	<#if "boolean" == type && "true" == value>
1<#return>
	<#elseif "boolean" == type>
0<#return>
	<#elseif "null" == value>
NULL<#return>
	<#elseif "string" == type>
"${value}"<#return>
	<#elseif "date" == type && "new" == value>
NULL<#return>
	<#else>
${value}<#return>
</#if>
</#macro>
<#if package?? && "" != package>
DROP DATABASE IF EXISTS ${package};
CREATE DATABASE ${package} DEFAULT CHARACTER SET UTF8 COLLATE UTF8_GENERAL_CI;

USE ${package};

	<#if objects??>
		<#list objects as object>
			<#if object.nameTable?? && "" != object.nameTable>
#----------------------------------------------------------------------------
				<#if object.note?? && "" != object.note>
#${object.note}
				</#if>
DROP TABLE IF EXISTS ${object.nameTable};
CREATE TABLE ${object.nameTable}(
				<#assign needComma = false/>
				<#list object.properties as property>
					<#if property.name?? && "" != property.name>
						<#if property.typeDB??>
							<#if "" != property.typeDB>
								<#if property.valueDB??>
	<#if needComma>, </#if>${property.name} ${property.typeDB?upper_case}<#if property.restrictDB?? && "" != property.restrictDB> ${property.restrictDB?upper_case}</#if><#if "" != property.valueDB> DEFAULT ${property.valueDB}</#if><#if property.note?? && "" != property.note> COMMENT "${property.note}"</#if>
								<#elseif property.value??>
	<#if needComma>, </#if>${property.name} ${property.typeDB?upper_case}<#if property.restrictDB?? && "" != property.restrictDB> ${property.restrictDB?upper_case}</#if><#if "" != property.value> DEFAULT ${property.value}</#if><#if property.note?? && "" != property.note> COMMENT "${property.note}"</#if>
								<#else>
	<#if needComma>, </#if>${property.name} ${property.typeDB?upper_case}<#if property.restrictDB?? && "" != property.restrictDB> ${property.restrictDB?upper_case}</#if><#if property.note?? && "" != property.note> COMMENT "${property.note}"</#if>
								</#if>
								<#assign needComma = true/>
							</#if>
						<#elseif property.type?? && "" != property.type>
							<#if "boolean" == property.type || "integer8" == property.type || "integer16" == property.type || "integer32" == property.type || "integer64" == property.type || "decimal32" == property.type || "decimal64" == property.type || "string" == property.type || "date" == property.type>
								<#if property.valueDB??>
	<#if needComma>, </#if>${property.name} <@typeTransfer type = property.type/><#if property.restrictDB?? && "" != property.restrictDB> ${property.restrictDB?upper_case}</#if><#if "" != property.valueDB> DEFAULT <@valueTransfer type = property.type value = property.valueDB/></#if><#if property.note?? && "" != property.note> COMMENT "${property.note}"</#if>
								<#elseif property.value??>
	<#if needComma>, </#if>${property.name} <@typeTransfer type = property.type/><#if property.restrictDB?? && "" != property.restrictDB> ${property.restrictDB?upper_case}</#if><#if "" != property.value> DEFAULT <@valueTransfer type = property.type value = property.value/></#if><#if property.note?? && "" != property.note> COMMENT "${property.note}"</#if>
								<#else>
	<#if needComma>, </#if>${property.name} <@typeTransfer type = property.type/><#if property.restrictDB?? && "" != property.restrictDB> ${property.restrictDB?upper_case}</#if><#if property.note?? && "" != property.note> COMMENT "${property.note}"</#if>
								</#if>
								<#assign needComma = true/>
							</#if>
						</#if>
					</#if>
				</#list>
)DEFAULT CHARSET = UTF8 COLLATE UTF8_GENERAL_CI<#if object.autoIncrement??> AUTO_INCREMENT = ${object.autoIncrement}</#if>;
DESC ${object.nameTable};
			</#if>
		</#list>
	</#if>
</#if>