<#macro typeTransfer type>
	<#if "boolean" == type>
System.Boolean<#return>
	<#elseif "integer8" == type>
System.Byte<#return>
	<#elseif "integer16" == type>
System.Int16<#return>
	<#elseif "integer32" == type>
System.Int32<#return>
	<#elseif "integer64" == type>
System.Int64<#return>
	<#elseif "decimal32" == type>
System.Single<#return>
	<#elseif "decimal64" == type>
System.Double<#return>
	<#elseif "string" == type>
System.String<#return>
	<#elseif "date" == type>
System.DateTime<#return>
	<#elseif "object" == type>
System.Object<#return>
	<#elseif "array" == type>
System.Collections.Generic.List<System.Object><#return>
	<#elseif "dictionary" == type>
System.Collections.Generic.Dictionary<System.Object, System.Object><#return>
	<#else>
${type}<#return>
	</#if>
</#macro>
<#macro valueTransfer type value>
	<#if "boolean" == type && "true" == value>
true<#return>
	<#elseif "boolean" == type>
false<#return>
	<#elseif "integer64" == type>
${value}L<#return>
	<#elseif "decimal32" == type>
${value}F<#return>
	<#elseif "date" == type>
System.DateTime.Now<#return>
	<#elseif "null" == value>
null<#return>
	<#elseif "string" == type>
"${value}"<#return>
	<#elseif "array" == type && "new" == value>
new System.Collections.Generic.List<System.Object>()<#return>
	<#elseif "dictionary" == type && "new" == value>
new System.Collections.Generic.Dictionary<System.Object, System.Object>()<#return>
	<#else>
${value}<#return>
</#if>
</#macro>
<#if object??>
	<#list object.importsNet as import>
using ${import};
		<#if import_index + 1 == object.importsNet?size>

		</#if>
	</#list>
</#if>
<#if package?? && "" != package>
namespace ${package}
{
</#if>
<#if object??>
	<#if object.name?? && "" != object.name>
		<#if object.note?? && "" != object.note>
<#if package?? && "" != package>	</#if>/// <summary>
<#if package?? && "" != package>	</#if>/// ${object.note}
<#if package?? && "" != package>	</#if>/// </summary>
		</#if>
<#if package?? && "" != package>	</#if>public class ${object.name}<#if object.extend?? && "" != object.extend> : ${object.extend}</#if>
<#if package?? && "" != package>	</#if>{
<#if package?? && "" != package>	</#if>	//============================================================================
<#if package?? && "" != package>	</#if>	//PROPERTY
<#if package?? && "" != package>	</#if>	//============================================================================
		<#list object.properties as property>
			<#if property.name?? && "" != property.name>
				<#if property.typeNet??>
					<#if "" != property.typeNet>
						<#if property.valueNet??>
<#if package?? && "" != package>	</#if>	private ${property.typeNet} _${property.name}<#if "" != property.valueNet> = ${property.valueNet}</#if>;
						<#elseif property.value??>
<#if package?? && "" != package>	</#if>	private ${property.typeNet} _${property.name}<#if "" != property.value> = ${property.value}</#if>;
						<#else>
<#if package?? && "" != package>	</#if>	private ${property.typeNet} _${property.name};
						</#if>
					</#if>
				<#elseif property.type?? && "" != property.type>
					<#if property.valueNet??>
<#if package?? && "" != package>	</#if>	private <@typeTransfer type = property.type/> _${property.name}<#if "" != property.valueNet> = <@valueTransfer type = property.type value=property.valueNet/></#if>;
					<#elseif property.value??>
<#if package?? && "" != package>	</#if>	private <@typeTransfer type = property.type/> _${property.name}<#if "" != property.value> = <@valueTransfer type = property.type value=property.value/></#if>;
					<#else>
<#if package?? && "" != package>	</#if>	private <@typeTransfer type = property.type/> _${property.name};
					</#if>
				</#if>
			</#if>
		</#list>
<#if package?? && "" != package>	</#if>	//============================================================================
<#if package?? && "" != package>	</#if>	//CONSTRUCTOR
<#if package?? && "" != package>	</#if>	//============================================================================
<#if package?? && "" != package>	</#if>	public ${object.name}() {}
<#if package?? && "" != package>	</#if>	//============================================================================
<#if package?? && "" != package>	</#if>	//GETTER_SETTER
<#if package?? && "" != package>	</#if>	//============================================================================
		<#assign needGap = false/>
		<#list object.properties as property>
			<#if property.name?? && "" != property.name>
				<#if property.typeNet??>
					<#if "" != property.typeNet>
						<#if needGap>

						</#if>
						<#assign needGap = true/>
						<#if property.note?? && "" != property.note>
<#if package?? && "" != package>	</#if>	/// <summary>
<#if package?? && "" != package>	</#if>	/// ${property.note}
<#if package?? && "" != package>	</#if>	/// </summary>
						</#if>
<#if package?? && "" != package>	</#if>	public ${property.typeNet} ${property.name?cap_first}
<#if package?? && "" != package>	</#if>	{
<#if package?? && "" != package>	</#if>		get { return _${property.name}; }
<#if package?? && "" != package>	</#if>		set { this._${property.name} = value; }
<#if package?? && "" != package>	</#if>	}
					</#if>
				<#elseif property.type?? && "" != property.type>
					<#if needGap>

					</#if>
					<#assign needGap = true/>
					<#if property.note?? && "" != property.note>
<#if package?? && "" != package>	</#if>	/// <summary>
<#if package?? && "" != package>	</#if>	/// ${property.note}
<#if package?? && "" != package>	</#if>	/// </summary>
					</#if>
<#if package?? && "" != package>	</#if>	public <@typeTransfer type = property.type/> ${property.name?cap_first}
<#if package?? && "" != package>	</#if>	{
<#if package?? && "" != package>	</#if>		get { return _${property.name}; }
<#if package?? && "" != package>	</#if>		set { this._${property.name} = value; }
<#if package?? && "" != package>	</#if>	}
				</#if>
			</#if>
		</#list>

<#if package?? && "" != package>	</#if>}
	</#if>
</#if>
<#if package?? && "" != package>
}
</#if>